/* upload.js
 *
 * Based on Torisugari's BookmarksFTP code.
 *
 * Part of InfoLister by Nickolay Ponomarev <asqueella@gmail.com>
 * Copyright (c) 2004-2005, Nickolay Ponomarev.
 * See the license.txt included in this package for licensing information.
 *
 * (this file needs to be cleaned up)
 *
 */

/*******  InfoLister-specific stuff  ******************************************/
/*       (will eventually be moved to a separate file)                        */
var ILUploadJob = {
  // the nsIURI to upload to
  get targetURI() {
    var prefs = ILPrefs.getSubBranch("ftp.");
    var URI = ILHelpers.createInstance("network/standard-url;1", "nsIURI");

    var host = prefs.getUnicharPref("host");
    var path = prefs.getUnicharPref("path");
    var username = prefs.getUnicharPref("username");
    var protocol = prefs.getUnicharPref("protocol");//xxx ascii
    var password = "";

    if(!host || !path) return null; //xxx

    if(path[0] != "/") // xxx?
      path = "/" + path;

    try {
      var out_host = { value : "" };
      var out_username = { value : "" };
      var out_password = { value : "" };
      var pm = ILHelpers.createInstance("passwordmanager;1", "nsIPasswordManagerInternal");
      pm.findPasswordEntry(host, username, "", out_host, out_username, out_password);
      username = out_username.value;
      password = out_password.value;
      host = out_host.value;
    } catch(e) {
      //xxx ask password now
    }

    URI.spec = protocol + "://" + username + ":" + password + "@" + host + path;
    debug_dump("job.targetURI=" + URI.spec);
    return URI;
  },
  
  // the nsIInputStream to upload
  get streamToUpload() {
    function getFileToUpload() {
      if( ("arguments" in window) && (0 in window.arguments) )
        return window.arguments[0];
      return null;
    }
    function readTextFile(file)
    {
      var fileStream = Components.classes['@mozilla.org/network/file-input-stream;1']
              .createInstance(Components.interfaces.nsIFileInputStream);
      var scriptableStream = Components.classes['@mozilla.org/scriptableinputstream;1']
              .createInstance(Components.interfaces.nsIScriptableInputStream);
      var str="";
      try {
        fileStream.init(file, 1, 0, false);
        scriptableStream.init(fileStream);
        while (scriptableStream.available()) {
          str += scriptableStream.read(scriptableStream.available());
        }
        //str += scriptableStream.read(-1);
        scriptableStream.close();
        fileStream.close();
      } catch(e) {
        ILHelpers.dumpException(e);
        ILHelpers.dump("the problem was with file.path="+file.path);
        alert(e);
      }
      return str;
    }
    
    var file = getFileToUpload();
    var str = readTextFile(file);
    debug_dump("streamToUpload: read "+str.length+" bytes from "+file.path);

    var stringStream = Components.classes["@mozilla.org/io/string-input-stream;1"]
                        .createInstance(Components.interfaces.nsIStringInputStream);
    stringStream.setData(str, -1);
    return stringStream;
  },

  get contentType() {
    return "text/xml"; //xxx?
  }
}


/*******  The upload service  *************************************************/
var gUploadService = {
  // process aJob - uploads contents of aJob.streamToUpload to aJob.targetURI
  sendData: function(aJob) {
    try {
      var uri = aJob.targetURI;
      var stream = aJob.streamToUpload;
      
      if(!stream || !uri) {
        flagedExit(-1);
        return;
      }
      debug_dump("uploadService.sendData: uploading " + stream + " to " + uri + ".");
      var iosvc = ILHelpers.getService("network/io-service;1", "nsIIOService");
      this.channel = ILHelpers.QI(iosvc.newChannelFromURI(uri), "nsIUploadChannel");
      debug_dump("uploadService.sendData: calling " + this.channel + ".setUploadStream()");
      this.channel.setUploadStream(stream, aJob.contentType, -1);

      debug_dump("calling asyncOpen()...");
      setStatusText("send", null);
      this.channel.asyncOpen(this, window);
    } catch(e) {
      ILHelpers.dumpException(e);
      var x = RegExp("^([^:]*://)([^:]*):([^@]*)@(.*)$").exec(uri.spec);
      if(x) { // strip name/password data
        var uristr = x[1] + ((x[2].length>0) ? "[name]" : "") + ":" +
                   ((x[3].length>0) ? "[password]" : "") + "@" + x[4];
      } else
        uristr = "{bad uri: " + uri.spec + "}"; // presumably no private info there
      ILHelpers.dump("uri="+uristr+"; file="+file.path);
      alert(e);
      flagedExit(-2);
    }
  },

  cancel: function()
  {
    if(this.channel)
      this.channel.cancel(0x804b0002); // xxx magic number
  },

  onDataAvailable: function(aChannel, aCtxt, aInStr, aSourceOffset, aCount) {},
  onStartRequest: function(aChannel, aCtxt) {},
  onStopRequest: function(aChannel, aCtxt, aErrCode) {
    try {
      debug_dump("onStopRequest("+aErrCode+")");
      ILHelpers.QI(aCtxt, "nsIDOMWindowInternal").flagedExit(aErrCode);
    } catch(e) {}
  }
};


/*******  Dialog interface  ***************************************************/
var gLifeTime = 2;
var gStringBundle;

//-------- event handlers
function StartUp()
{
  gStringBundle = document.getElementById("strbundle");
  setStatusText("ready", null);
  gUploadService.sendData(ILUploadJob);
}

//-------- mantain status text

// updates status text and initiates window close if aCode does not indicate
// an error
function flagedExit(aCode)
{
  setStatusText("", aCode);

  if(aCode == 0) // uploaded successfully
    setTimeout(close, 2000);
  else // xxx beep, perhaps?
    window.getAttention();
}


const netErrorStrings = {
  "1": "unexpected",
  "2": "usercancel",
  "13": "refused",
  "14": "netTimeout",
  "16": "netOffline",
  "21": "ftplogin",
  "22": "ftpcwd",
  "23": "ftppasv",
  "24": "ftppwd",
  "25": "ftplist",
  "30": "unknown"
};

function getErrorStr(aCode)
{
  const MAGIC_NUMBER = 0x804b0000; // ;-)
  if(aCode == 0) return "done";
  if(aCode < MAGIC_NUMBER) return "notneterror";
  aCode %= MAGIC_NUMBER;
  debug_dump(aCode);
  if(aCode in netErrorStrings)
    return netErrorStrings[aCode];
  return "unexpected";
}

function getLocalizedString(aStr) {
  try {
    return gStringBundle.getString(aStr);
  } catch(e) {}
  return aStr;
}

// aMsg is either undefined or one of strings from neterrors.properties,
// aErrCode is either undefined or an error code.
// At least one of params must be defined.
function setStatusText(aMsg, aErrCode)
{
  var status;
  if(aMsg) {
    status = getLocalizedString(aMsg);
  } else {
    aMsg = getErrorStr(aErrCode);
    status = getLocalizedString(aMsg);
  }
  if(aMsg == "notneterror" || aMsg == "unexpected")
    status += " (" + aErrCode + ")";

  document.getElementById("status").value = status;
}

function debug_dump(aStr) {
//  ILHelpers.dump(aStr);
}

